//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2011-2011 - DIGITEO - Bruno JOFRET
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//
//

function [x,y,typ]=PARAM_VAR(job,arg1,arg2)
  x=[];y=[];typ=[];
  select job
   case 'plot' then
// deprecated
   case 'getinputs' then
// deprecater
   case 'getoutputs' then
// deprecated
   case 'getorigin' then
// deprecated
   case 'set' then
    x=arg1;
    graphics=arg1.graphics;
    exprs=graphics.exprs
    model=arg1.model;

// Boite de dialogue pour indiquer les paramètres à faire varier (3 maximum) et leurs valeurs   
    while %t do
      [ok,param1,param1val,param2,param2val,param3,param3val, exprs]=scicos_getvalue('Varying parameters and their values',..
                                                ['1st parameter','1st parameter values','2nd parameter','2nd parameter values',...
                                                '3rd parameter','3rd parameter values'], ..
                                                list('str',-1,'vec',-1,'str',-1,'vec',-1,'str',-1,'vec',-1),exprs');



//      [ok,param1,param1val,param2,param2val,param3,param3val, exprs]=scicos_getvalue('Varying parameters and their values',..
//                                                ['1st parameter','1st parameter values','2nd parameter','2nd parameter values',...
//                                                '3rd parameter','3rd parameter values'], ..
//                                                list('str',-1,'vec',-1,'str',-1,'vec',-1,'str',-1,'vec',-1),[exprs(1),exprs(2),exprs(3),]);
          mess=[];

          if ~ok then
// Cancel
              break;
          end
            // Verification de l'existence des paramètres à faire varier
          if (~isempty(param1) & ~exists(param1)) | (~isempty(param2) & ~exists(param2) ) | (~isempty(param3) & ~exists(param3))
              mess=[mess ;_("One (or several) parameters is (are) not defined in the context")]
              ok = %f
          end
          
          // Vérification que pour chaque paramètre, des valeurs sont définies
          if (~isempty(param1) & isempty(param1val)) | (~isempty(param2) & isempty(param2val) ) | (~isempty(param3) & isempty(param3val))
              mess=[mess ;_("One (or several) parameters values are not defined")]
              ok = %f
          end
                         
          //execstr(instr)
          //string
                        
          if ok then
// Everything's ok
              model.opar=list(param1,param1val,param2,param2val,param3,param3val)
              graphics.exprs=exprs;
              x.model=model;
              x.graphics=graphics;
              break;
          else
              message(mess);
          end

end

  
     case 'define' then
      model=scicos_model();
        k=1;
        model.sim=list("PARAM_VAR",99) // 99 type blocks are ignored by simulator.
        model.blocktype='c';
        model.dep_ut=[%f %f];
        model.in=[];
        model.intyp=[];
        model.out=[];
        model.outtyp=[];
        model.ipar=[1]
        model.rpar=[1;1];
        model.opar=list()
        x=standard_define([2 2],model,[],[]);
        x.graphics.in_implicit=[];
        x.graphics.out_implicit=[];
        x.graphics.style=["blockWithLabel;verticalLabelPosition=center;displayedLabel=Param. varation"]
        x.graphics.exprs=["k";"[1 2 3]";"";"";"";""]
    end
endfunction
