//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2010-2010 - DIGITEO - Bruno JOFRET
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//
//

function []=Param_Var_pre_simulate(scs_m, needcompile)
  disp("Calling Param_Var_pre_simulate...");
//On crée un nouveau fichier scs pour ne pas écraser le premier
scs=scs_m
// Retrieve all objects
    objects = scs_m.objs;
    
    nombre_blocs=0;    //Nombre de blocs dans le diagramme
    nombre_liens=0;    //Nombre de lien dans le diagramme
    
    param1="";
    param1val=[];
    param2="";
    param2val=[];
    param3="";
    param3val=[];
    
    
//Récupère le nombre de blocs dans le modèle
    for i=1:size(objects)
        if typeof(objects(i))=='Block' then
            nombre_blocs=nombre_blocs+1;
        end
    end
nombre_liens=size(objects)-nombre_blocs;  //calcul du nombre de liens

// On récupere le numéro du bloc PARAM_VAR puis les caractéristiques correspondantes
for i = 1:size(scs.objs)
    curObj= scs.objs(i);
        if (typeof(curObj) == "Block" & curObj.gui == "PARAM_VAR")
            if length(curObj.model.opar)>0 then 
                param1=curObj.model.opar(1)
                param1val=curObj.model.opar(2)
            end
            if length(curObj.model.opar)>2 then 
                param2=curObj.model.opar(3)
                param2val=curObj.model.opar(4)
            end
            if length(curObj.model.opar)>4 then 
                param3=curObj.model.opar(5)
                param3val=curObj.model.opar(6)
            end
        end
end

nombre_scope=0 //Nombre de scope trouvé

//On va modifier le scs pour remplacer les scopes de la toolbox par des des bloc to_workspace
 for i =  1:size(scs.objs)
    curObj= scs.objs(i);
        if (typeof(curObj) == "Block" & curObj.gui == "DSUPER")   //On vérifie qu'on a trouvé un bloc autoscope
            if curObj.model.rpar.objs(1).gui=="CSCOPE" then

    nombre_scope=nombre_scope+1;
       // Décale tous les liens d'un cran
       typeof(scs_m)
       typeof(scs)
       toto=scs
       typeof(toto)
       for w=1:nombre_liens
       num=nombre_blocs+nombre_liens+1-w
       toto.objs(num+1)=toto.objs(num)
       end
       scs=toto
             
           
                     
            //On décale tout les pin et pout des blocs pour rester en concordances avec les liens
            for l=1:nombre_blocs
                if ~isempty(scs.objs(l).graphics.pin) then scs.objs(l).graphics.pin=scs.objs(l).graphics.pin+1
                end
                if ~isempty(scs.objs(l).graphics.pout) then scs.objs(l).graphics.pout=scs.objs(l).graphics.pout+1
                end
                if ~isempty(scs.objs(l).graphics.pein) then scs.objs(l).graphics.pein=scs.objs(l).graphics.pein+1
                end
                if ~isempty(scs.objs(l).graphics.peout) then scs.objs(l).graphics.peout=scs.objs(l).graphics.peout+1
                end
            end
            
             // Crée un bloc to clock_c en tant qu'objet nombre blocs+1 avec le numéro d'entrée correspondant
             // Le plus simple est de recopier le bloc cloc_c du scope auto
            nombre_blocs=nombre_blocs+1;   // Le nombre de bloc est incrémenté
            scs.objs(nombre_blocs)=scs.objs(i).model.rpar.objs(2) // Crée un nouveau bloc clock identique à celui qui était dans le scope auto
            
            [ok,num_p,temps]=getvalue('Paramètre de la simulation',["Nombre de points","Durée de simulation"],list('vec','1','vec',1),['200','20'])
            
            scs.props.tf=temps;
            scs.objs(nombre_blocs).model.rpar.objs(2).model.rpar=[temps/num_p,0]
            scs.objs(nombre_blocs).model.rpar.objs(2).graphics.exprs=list(string(temps/num_p),"0")
            
            //Remplace le blocs scope auto par un bloc to_workspace
            // on récupere d'abord le numero du lien d'éntree
            graphics=scs.objs(i).graphics
            scs.objs(i)=TOWS_c('define')
            scs.objs(i).graphics.orig=graphics.orig
            scs.objs(i).graphics.sz=graphics.sz
   //jusque là ça va         
           
            //num_point=scs.objs(nombre_blocs).model.rpar.objs(2).model.rpar(1)*tf;
            
            scs.objs(i).graphics.exprs=[string(num_p);"A"+string(nombre_scope);"0"]
            scs.objs(i).graphics.pin=graphics.pin
            
            scs.objs(i).model.ipar=[num_p;1;-10];
            
            //On crée le lien supplémentaire nécessaire
            nombre_liens=nombre_liens+1
            scs.objs(size(scs.objs)+1)=scicos_link()
            scs.objs(size(scs.objs)).xx=[scs.objs(i).graphics.orig(1) scs.objs(nombre_blocs).graphics.orig(1)]
            scs.objs(size(scs.objs)).yy=[scs.objs(i).graphics.orig(2) scs.objs(nombre_blocs).graphics.orig(2)] 
            scs.objs(size(scs.objs)).id='drawlink'
            scs.objs(size(scs.objs)).thick=[0 0]
            scs.objs(size(scs.objs)).ct=[5 -1]
            scs.objs(size(scs.objs)).from=[nombre_blocs 1]
            scs.objs(size(scs.objs)).to=[i 1]
            
            //On relie la clock au nouveau lien
            scs.objs(nombre_blocs).graphics.peout=nombre_liens+nombre_blocs
            //Idem pour l'entre explicite to To_wks
            scs.objs(i).graphics.pein=nombre_liens+nombre_blocs
            
            end
        end
end

num_param=0;
if ~isempty(param1) then num_param=num_param+1;
end
if ~isempty(param2) then num_param=num_param+1;
end
if ~isempty(param3) then num_param=num_param+1;
end


Nsimu=0  //Numero de la simu
x=0
D=[]
winId=waitbar('Simulation in progress')

z=[]
for z=1:nombre_scope
    handle_fig(z)=figure();
end
legend_c=[]
c_color=['b','r','k','g','c','m']
select num_param
case 1

    for i=1:length(param1val)
        x=(i-1)/length(param1val)
        waitbar(x,winId)
        execstr("cont"+"."+param1+"="+string(param1val(i)))
        scicos_simulate(scs,cont)
        legend_c(i)=string(param1)+'='+string(param1val(i))
        Nsimu=Nsimu+1;
        // On enregistre chacune des variables dans une matrices
        //Pour cela on créee une structure D(i,j)
        //la variable i de la simu j est stockée dans D(i,j)
        
                      
        for l=1:nombre_scope
            D(l,Nsimu)=evstr("A"+string(l))
            scf(handle_fig(l))
            plot(D(l,Nsimu).time,D(l,Nsimu).values,'color',c_color(modulo(Nsimu,6)),'thickness',2)
            set(handle_fig(l),"background",8)
            xgrid
        end
    end
    legend(legend_c)
    
        
     winclose(winId);

//case 2
//for i=1:length(param1val)
//    x=(i-1)/length(param1val)
//    waitbar(x,winId)
//    execstr("cont"+"."+param1+"="+string(param1val(i)))
//    for j=1:length(param2val) then
//        execstr("cont"+"."+param2+"="+string(param2val(j)))
//        Nsimu=Nsimu+1;
//        scicos_simulate(scs,cont);
//        legend_c(Nsimu)=string(param1)+'='+string(param1val(i))+', '+string(param2)+'='+string(param2val(i));
//        // On enregistre chacune des variables dans une matrices
//        //Pour cela on créee une structure D(i,j)
//        //la variable i de la simu j est stockée dans D(i,j)
//
//
//        for l=1:nombre_scope
//            D(l,Nsimu)=evstr("A"+string(l));
//            scf(handle_fig(l));
//            plot(D(l,Nsimu).time,D(l,Nsimu).values,'color',c_color(modulol,6),'thickness',2);
//            set(handle_fig(l),"background",8);
//            xgrid;
//            legend(legend_c);
//        end
//
//  end 
//
//end

winclose(winId);


//case 3
//    for i=1:length(param1val)
//        context=scs.props.context
//        context($+1)=string(param1)+"="+string(param1val(i))
//        for j=1:length(param2val)
//            context($+1)=string(param2)+"="+string(param2val(i))
//            for j=1:length(param3val)
//            context($+1)=string(param3)+"="+string(param3val(i))
//            scicos_simulate(scs,context)
//            Nsimu=Nsimu+1;
//            // On enregistre chacune des variables dans une matrices
//        //Pour cela on créee une structure D(i,j)
//        //la variable i de la simu j est stockée dans D(i,j)
//        for l=1:nombre_scope
//            D(l,Nsimu)=evstr("A"+l)
//        end
//        
//        // Enfin on trace chacune des variables
//        for n=1:nombre_scope
//            figure()
//            for o=1:Nsimu
//            xy=D(n,o);
//            plot(xy.time,xy.value)
//            //Il reste la légende à traiter            
//            end
//        end
//        end
//     end
//end
 end
endfunction
